%{
 #include "SYMTABLE.C"
%}

 char lintext[132];
c        [cC]
o        [oO]
n        [nN]
u        [uU]
s        [sS]
t        [tT]
v        [vV]
e        [eE]
l        [lL]
i        [iI]
b        [bB]
r        [rR]
a        [aA]
y        [yY]
delim      [ \t]
novalinha  [\n]
espacos    {delim}+
letra      [A-Za-z_]
digito     [0-9]
ident      {letra}({letra}|{digito})*
numero     {digito}+
%%
{espacos}    {strcat(lintext," ");}; /* ignora espacos */
{novalinha}  {emit(yyout,";debug linha %d: %s\n",++numlin,lintext);
	      strcpy(lintext,"");};
{u}{s}{e}{s}{espacos}{l}{i}{b}{r}{a}{r}{y} {strcpy(lintext,yytext);
                                            return LIBRARY;}
{c}{o}{n}{s}{t}  {
		  decl=1; /* area de declaracao */
		  strcat(lintext,yytext);
                  aux=pesquisa_global(yytext);
                  return(CONST);
                 }
{v}{a}{r}        {
		  decl=1; /* area de declaracao */
                  strcat(lintext,yytext);
                  aux=pesquisa_global(yytext);
                  return(VAR);
                 }
{ident}      {
	       if(yyleng>32){ /* comprimento maximo de um id e 32 caract. */
                 char s[33];
                 printf("Aviso, lin %d: Identificador muito longo.\nId:%s\n",
                                       numlin, yytext);
                 strncpy(s,yytext,32);
		 strcpy(yytext,s);
	       }
              strcat(lintext,yytext);
	      if(aux=pesquisa_global(yytext)){
                 incr_ref(aux);
                 return (aux->token);
               }
	       else if(!decl){ /* se nao existe o id e nao e uma area de */
			       /* declaracao entao e um id nao declarado */
                 printf("Erro, lin %d: identificador \"%s\" nao declarado.\n",numlin,yytext);
		 return IDENT;
	       }else{ /* se nao existe e e uma area de declaracao entao insere */
                 aux=insere_nodo(yytext);
                 poe_token(IDENT);
                 poe_linha();
                 incr_ref(aux);
                 return IDENT;
               }
             };


{numero}     {
                 strcat(lintext,yytext);
		 sscanf(yytext, "%i", &yylval);
                 return NUMERO;
             };

.            {strcat(lintext,yytext);return yytext[0];}
%%



